/*Tutor. Paolo Pasteris
  Lab Multimedia II 12/13 Unimi
  Chroma Key using HSB space.
*/
import java.awt.Color;

PImage layer,backgr,img_binary,alphaImage;

float targetHue;
float Htollerance,
      Stollerance,
      Vtollerance;

void setup() {
  backgr = loadImage("sky.jpg");
  layer = loadImage("batman.jpg");
  img_binary=createImage(layer.width,layer.height,RGB);
  alphaImage=createImage(layer.width,layer.height,ARGB);
  //valori presi con gimp e normalizzati tra 0 e 1
  targetHue=134f/360f;
  //targetHue=45f/360f;
  Htollerance=0.15f;
  Stollerance=0.3f;
  Vtollerance=0.3f;
  
  size(backgr.width*3,backgr.height);
  noLoop();
  background(255);
}

void draw() {
  
  chromaKey(layer,backgr);
  image(backgr,0, 0);
  image(img_binary, img_binary.width, 0);
  image(alphaImage, alphaImage.width*2, 0);
  savePNG(alphaImage);
}

void chromaKey(PImage layer,PImage backgr){
  int dimension=layer.width*layer.height;
  int r,g,b;
  float[] hsb=new float[3];
  float deltaHue,alpha_channel;
    
  backgr.loadPixels();
  layer.loadPixels();
  img_binary.loadPixels();
  alphaImage.loadPixels();
  
  for(int i=0;i<dimension;i++){
    //Color space convertion
    Color.RGBtoHSB((int)red(layer.pixels[i]),(int)green(layer.pixels[i]),(int)blue(layer.pixels[i]), hsb);
    //Hue difference
    deltaHue = Math.abs(hsb[0]-targetHue);
    if(deltaHue < Htollerance && hsb[1]> Stollerance && hsb[2]> Vtollerance){
      alpha_channel=0;      
    }else{
      alpha_channel=1;
    }
    
    r=(int)(alpha_channel*red(layer.pixels[i])+(1-alpha_channel)*red(backgr.pixels[i]));
    g=(int)(alpha_channel*green(layer.pixels[i])+(1-alpha_channel)*green(backgr.pixels[i]));
    b=(int)(alpha_channel*blue(layer.pixels[i])+(1-alpha_channel)*blue(backgr.pixels[i]));

    img_binary.pixels[i] = color(alpha_channel*255,alpha_channel*255,alpha_channel*255); 
    alphaImage.pixels[i]=color(r,g,b,alpha_channel*255);
    backgr.pixels[i]=color(r,g,b);
  }
  alphaImage.updatePixels();
  img_binary.updatePixels();
  backgr.updatePixels();
}
void savePNG(PImage img){
  img.save("frame.png");
}
